export default ()=>{
	//批量读取user_meta的时候，在meta里面增加avatar_url
	add_filter('get_user_metadata', (result, user_id, key) => {
		if ((key == undefined || key == null) && (result instanceof Object) ) {
			//没有key，同时结果是对象，那么判断有没有avatar_id，有的话，计算出avatar_url
			var media_id = result.avatar_id;
			if (media_id) {
				var media = nv_get_media(media_id);
				if (media) {
					result.avatar_url = media.urls.original;
				}
			}
		}
		return result;
	})

	//单独读取avatar_url的时候，尝试处理
	add_filter('get_user_metadata', (result, user_id, key) => {
		if (key == "avatar_url") {
			var media_id = get_user_meta(user_id,'avatar_id');
			if (media_id) {
				var media = nv_get_media(media_id);
				if (media) {
					return media.urls.original;
				}
			}
		}
		return result;
	})

	//直接读取 user 信息的时候，加上用户的 avatar
	add_filter('get_user',(user,id)=>{
		return {
			...user,
			avatar_url: get_user_meta( id, 'avatar_url' ),
			last_logon_date: get_user_meta( id, 'last_logon_date' ),
		}
	})
}