//读取命令行参数
import minimist from "minimist";
import * as path from 'path'
import { pathToFileURL } from 'url'

export default async ()=>{
	const args = minimist(process.argv)

	// 记录已经启用的插件
	global.nv_enabled_plugin_folders = [];
	global.nv_error_plugin_folders = [];

	var all_plugins = nv_plugin_list();
	var setted_plugin_folders = get_option('_nv_selected_plugin_folders',[]);

	if ( !Array.isArray(setted_plugin_folders) ) {
		setted_plugin_folders = [];
		delete_option('_nv_selected_plugin_folders');
		console.log('要求被启用的插件数据记录错误')
	}

	// 从所有插件中筛选出正常可启用的插件
	var good_plugin_folders = all_plugins.filter(p=> !p.error).map(p=>p.folder);

	// 挨个启用匹配到的插件
	for (var i = 0; i < setted_plugin_folders.length; i++) {
		var folder = setted_plugin_folders[i]
		if (good_plugin_folders.includes(folder)) {
			// console.log(`加载插件：\x1B[36m${folder}\x1B[0m`)
			nv_log(
				'加载插件：',
				nv_log.info(folder)
			)
			await import(pathToFileURL(path.join(process.cwd(),`./nv-plugins/${folder}/function.js`)))
			.then(res=>{
				if (typeof(res) == 'function') {
					res();
				}
			})
			.catch(e=>{
				nv_error_plugin_folders.push(folder)
				nv_log(
					nv_log.error('插件错误：'),
					e
				)
			})
			nv_enabled_plugin_folders.push(folder)
		}
	}

	// 如果已启用的插件数量和要求启用的数量不匹配（说明有插件损坏），重新设置要求启用的插件（Docker中，正式环境才自动停用）
	if(nv_enabled_plugin_folders.length !== setted_plugin_folders.length && args.docker=='true') {
		set_option('_nv_selected_plugin_folders',nv_enabled_plugin_folders);
	}
}