export default ()=>{
	register_rest_route('nv','send-email',{
		methods: 'post',
		callback(data,req,res) {
			const {to, subject, message, name} = data;
			if (!to || !subject || !message) {
				return new NV_Error("参数错误");
			}
			if (name) {
				// 有名字：使用模板发送
				var user = {
					name,
					email: to
				}
				var paragraphs = message.replace(/\n\n+/g,'\n').split('\n');
				var mail = send_mail_to_user(user,subject,paragraphs);
			} else {
				// 无名字，把内容当做纯文本发送
				var mail = nv_mail(to, subject, message);
			}
			mail
			.then(info=>{
				res.json({});
				return;
			})
			.catch(err=>{
				res.json({error: '邮件发送失败'});
				console.log('邮件发送失败',err.message)
				return;
			})
		},
		permission_callback: power=>power >= 8,
	});
}