//读取命令行参数
import minimist from "minimist";
const process_args = minimist(process.argv)

export default ()=>{
	register_rest_route('nv','get-site-info',{
		methods: 'post',
		callback(data,req) {
			return apply_filters('admin_get_site_info',{
				site_name: get_option('nv_site_name',"nvPress"),
				site_description: get_option('nv_site_description',""),
				home_url: get_option('nv_home_url',""),
				date_format: get_option('nv_date_format',"l"),
				time_format: get_option('nv_time_format',"LT"),
				allow_register: get_option('nv_allow_register',false),
				has_admin: nv_count_admin() > 0,
				nv_version: nv_version,
				development: !process_args.docker,
				is_nv_content_folder_mounted: _is_nv_content_folder_mounted,
				is_nv_plugins_folder_mounted: _is_nv_plugins_folder_mounted,
				is_nv_themes_folder_mounted: _is_nv_themes_folder_mounted,
			})
		}
	});

	register_rest_route('nv','get-options',{
		methods: 'post',
		callback(data,req) {
			const {names} = data;
			if (!names) {
				return new NV_Error('参数错误');
			}
			var result = {};
			names.map(name=> {
				if (name) {
					result[name] = get_option(name);
				}
			});
			return result;
		},
		permission_callback: power=>power >= 10,
	});

	register_rest_route('nv','set-options',{
		methods: 'post',
		callback(data,req) {
			for(var name in data) {
				set_option(name,data[name]);
			}
			return {};
		},
		permission_callback: power=>power >= 10,
	});
}