export default ()=>{
	register_socket_route('nv','realtime',{
		callback(ws,req) {
			do_action("_realtime_inited",ws,req);

			ws.on('message',data => {
				do_action("_realtime_received",data,ws,req);
			})

			ws.on('close', () => {
				do_action("_realtime_closed",ws,req);
			});
		},
	});

	// realtime comment badages
	var allowed_comment_badge_ws = [];
	var reparse_comment_badge = ()=>{
		var comment_badge = 0;
		nvdb.comments.find(r=>{
			if ( ['pending'].includes(r.status) ) {
				comment_badge++
			}
			return;
		})
		return comment_badge;
	}
	var comment_badge = 0;

	add_action("_realtime_inited",(ws,req)=>{
		// 评论相关，手动鉴权
		var user = get_user_by_nonce( req.headers['sec-websocket-protocol'] );
		var current_user_power = is_nv_error(user) ? 0 : user.power;
		if (current_user_power < 8) {return;}
		allowed_comment_badge_ws.push(ws)

		if (allowed_comment_badge_ws.length == 1) {
			comment_badge = reparse_comment_badge();
		}
		ws.send(JSON.stringify({
			type: "menu_badge",
			data: {comments: comment_badge}
		}));
	})

	add_action("_realtime_closed",(ws,req)=>{
		var ws_index = allowed_comment_badge_ws.indexOf(ws);
		if ( ws_index >=0 ) {
			allowed_comment_badge_ws.splice(ws_index,1);
		}
	})

	var send_comment_badge_to_all_ws = ()=>{
		if (allowed_comment_badge_ws.length) {
			comment_badge = reparse_comment_badge();
			allowed_comment_badge_ws.forEach(ws=>{
				ws.send(JSON.stringify({
					type: "menu_badge",
					data: {comments: comment_badge}
				}));
			})
		}
	}

	add_action('nv_set_comments_status',send_comment_badge_to_all_ws);

	add_action("nv_comment_inserted", cmt=>{
		if ( ['pending'].includes(cmt.status) ) {
			send_comment_badge_to_all_ws();
		}
	})

	add_action("nv_after_delete_comment", cmt=>{
		if ( ['pending'].includes(cmt.status) ) {
			send_comment_badge_to_all_ws();
		}
	})
}