import minimist from "minimist";

export default ()=>{
	const process_args = minimist(process.argv)
	var is_development = !process_args.docker;

	register_rest_route('nv','get-theme-list',{
		methods: 'post',
		callback(data,req) {
			return {
				list: nv_theme_list(),
				current_theme: global.nv_current_theme_folder,
				selected_theme: get_option('_nv_selected_theme_folder','default'),
			}
		},
		permission_callback: power=>power >= 10,
	});


	register_rest_route('nv','set-theme',{
		methods: 'post',
		callback(data,req) {
			var {folderName} = data;
			set_option('_nv_selected_theme_folder',folderName);
			return {}
		},
		permission_callback: power=>power >= 10,
	});

	register_rest_route('nv','delete-themes',{
		methods: 'post',
		callback(data,req) {
			var {folderNames} = data;

			if (!folderNames) {
				return new NV_Error('参数错误');
			}

			if (is_development) {
				return new NV_Error('开发模式禁止删除！请手动在主题文件夹操作');
			}

			var everySuccess = folderNames.map(name=> nv_remove_folder(`./nv-themes/${name}`) )
			.every(i=>i);

			return everySuccess ? {} : new NV_Error(`${folderNames.length > 1 ? '部分' : ''}删除失败，请关闭服务后手动删除`);
		},
		permission_callback: power=>power >= 10,
	});
}